routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check())
        return redirect()->route('home');
    else
        return redirect()->route('login');
});

// Register login, register, password-reset, and other lovely core stuff.
Auth::routes();

Route::get('register/thanks', 'Auth\RegisterController@thanks')->name('register.thanks');
Route::get('register/to/{city_slug}/{section_id}', 'Auth\RegisterController@sectionPreload')->name('register.tosection');

Route::middleware(['auth'])->group(function () {
    Route::get('home', 'HomeController@index')->name('home');

    Route::post('user/approve', 'UserController@approve')->name('user.approve');
    Route::get('user/bypass/{id}', 'UserController@bypass')->name('user.bypass');

    Route::get('movement/review', 'MovementController@review')->name('movement.review');
    Route::post('movement/attach/{id}', 'MovementController@attach')->name('movement.attach');
    Route::post('movement/refund/{id}', 'MovementController@refund')->name('movement.refund');
    Route::get('movement/download', 'MovementController@download')->name('movement.download');

    Route::get('section/{id}/balance', 'SectionController@balance')->name('section.balance');
    Route::post('section/{id}/exportmembers', 'SectionController@exportmembers')->name('section.exportmembers');

    Route::get('refund/download', 'RefundController@download')->name('refund.download');

    Route::get('sponsor/logo/{id}', 'SponsorController@logo')->name('sponsor.logo');

    Route::get('doc/download', 'DocumentationController@download')->name('doc.download');
    Route::get('doc/link', 'DocumentationController@link')->name('doc.link');
    Route::get('doc/preview', 'DocumentationController@preview')->name('doc.preview');

    Route::post('assembly/partecipate/{assembly_id}/{do}', 'AssemblyController@partecipate')->name('assembly.partecipate');
    Route::post('assembly/delegate/{assembly_id}/{delegate_id}', 'AssemblyController@delegate')->name('assembly.delegate');

    Route::get('bank/list/', 'BankController@list')->name('bank.list_all');
    Route::get('bank/list/{id}', 'BankController@list')->name('bank.list');

    Route::resource('user', 'UserController');
    Route::resource('volunteer', 'VolunteerController');
    Route::resource('doc', 'DocumentationController');
    Route::resource('config', 'ConfigController');
    Route::resource('bank', 'BankController');
    Route::resource('movement', 'MovementController');
    Route::resource('rule', 'RuleController');
    Route::resource('section', 'SectionController');
    Route::resource('receipt', 'ReceiptController');
    Route::resource('refund', 'RefundController');
    Route::resource('assembly', 'AssemblyController');
    Route::resource('votation', 'VotationController');
    Route::resource('vote', 'VoteController');
    Route::resource('sponsor', 'SponsorController');
});

app/Refund.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Collection;

class Refund extends Model
{
    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function section()
    {
        return $this->belongsTo('App\Section');
    }

    public function movement()
    {
        return $this->belongsTo('App\Movement');
    }

    public function getPrintableDescriptionAttribute()
    {
        return sprintf('%s € - %s - %s', $this->amount, $this->user ? $this->user->printable_name : '?', $this->section ? 'Sezione Locale di ' . $this->section->city : 'Nessuna Sezione Locale');
    }

    public function getAttachmentsPathAttribute()
    {
        return storage_path('refunds/' . $this->id);
    }

    public function getAttachmentsAttribute()
    {
        $ret = new Collection();

        $path = $this->attachments_path;
        if (file_exists($path)) {
            $files = scandir($path);

            foreach($files as $f) {
                if ($f[0] == '.')
                    continue;

                $ret->push($f);
            }
        }

        return $ret;
    }

    public function attachFile($file)
    {
        $file->move($this->attachments_path, $file->getClientOriginalName());
    }

    /**
     * Get the RefundStatus object from this Refund.
     * @return RefundStatus
     */
    public function getRefundStatus()
    {
        return RefundStatus::findByID($this->refunded);
    }

}

app/Http/Controllers/RefundController.php
<?php

namespace App\Http\Controllers;

use App\RefundStatus;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class RefundController extends EditController
{
    public function __construct()
    {
        parent::init([
            'classname' => 'App\Refund',
            'view_folder' => 'refund',
        ]);
    }

    public function download(Request $request)
    {
        return response()->download(storage_path('refunds/' . $request->input('file')));
    }

    public function index()
    {
        //sovrascrivo il metodo index di EditController per passare altri dati necessari alla vista

        $request = request();

        $currentuser = Auth::user();

        $query = ($this->classname)::orderBy($this->defaultSortingColumn(), 'asc');
        $query = $this->query($query);
        $objects = $query->get();

        //region "#37 moved from blade file"

        // Note: the backend is "refunded" but at frontend is exposed as "status".
        $selected_statuses = [];
        $selected_refund_status_uids = $request->input('status');
        if (! is_array($selected_refund_status_uids)) {
            $selected_refund_status_uids = [];
            if ($currentuser->hasRole('admin')) {
                // Default filters for reviewers :)
                $selected_refund_status_uids[] = 'waiting';   // Check incoming stuff to be approved.
                $selected_refund_status_uids[] = 'approved';  // Check approved stuff to be paid.
                $selected_refund_status_uids[] = 'paid';      // Check paid stuff to be also verified.
            } else {
                // Default filters for normal users :)
                $selected_refund_status_uids[] = 'waiting';   // See my pending stuff.
                $selected_refund_status_uids[] = 'approved';  // See my approved stuff.
                $selected_refund_status_uids[] = 'blocked';   // See my blocked stuff so I can change things to make the board happier.
            }
        }
        foreach ($selected_refund_status_uids as $selected_refund_status_uid) {
            $selected_statuses[] = \App\RefundStatus::findByUID($selected_refund_status_uid);
        }
        if ($selected_statuses) {
            // WHERE status IN ( ... )
            $selected_status_ids = [];
            foreach ($selected_statuses as $status) {
                $selected_status_ids[$status->id] = $status->id;
            }
            $objects = $objects->whereIn('refunded', $selected_status_ids);
        }

        $min_date = \App\Refund::min('date');
        $max_date = \App\Refund::max('date');

        $min_year = date('Y', strtotime($min_date));
        $max_year = date('Y', strtotime($max_date));

        $users = [];
        if ($currentuser->hasRole('admin')) {
            $users = \App\User::whereIn('status', ['active'])->has('refunds')->orderBy('username', 'asc')->get();
            if ($request->input('user_id')) {
                $objects = $objects->where('user_id', $request->input('user_id'));
            }
        }

        $sections = \App\Section::orderBy('city', 'asc')->get();
        if ($request->input('section_id')) {
            $objects = $objects->where('section_id', $request->input('section_id'));
        }

        if ($request->input('year')) {
            $objects = $objects->filter(function ($object) use ($request) {
                return date('Y', strtotime($object->date)) == $request->input('year');
            });
        }

        $all_statuses = \App\RefundStatus::all();

        //region calculate the total amount of refunds
        $total = 0;
        $total_refunded = 0;
        foreach ($objects as $refund) {
            $total += $refund->amount;
            $total_refunded += ($refund->amount - ($refund->getRefundStatus()->completed ? $refund->amount : 0));
        }
        //endregion calculate the total amount of refunds

        //endregion "#37 moved from blade file"

        // Filter by Report availability.
        if( $request->input('report') === 'yes' ) {
            $objects = $objects->whereNotNull('report_url');
        } elseif( $request->input('report') === 'no' ) {
            $objects = $objects->whereNull('report_url');
        }

        return view($this->view_folder . '.index', [
            'objects' => $objects,
            'classname' => $this->classname,
            'view_folder' => $this->view_folder,
            'sorting' => $this->defaultSortingColumn(),
            'direction' => 'asc',
            'search' => '',
            'min_year' => $min_year,
            'max_year' => $max_year,
            'selected_statuses' => $selected_statuses,
            'users' => $users,
            'sections' => $sections,
            'all_statuses' => $all_statuses,
            'selected_refund_status_uids' => $selected_refund_status_uids,
            'total' => $total,
            'total_refunded' => $total_refunded,
            'report_options' => $this->getReportURLOptions(),
        ]);
    }

    protected function query($query, $id = null)
    {
        $user = Auth::user();

        if ($user->hasRole('admin') == false) {
            $query->where('user_id', $user->id);
        }

        $query->orderBy('updated_at', 'asc');

        return $query;
    }

    protected function requestToObject($request, $object)
    {
        $object->date = $request->input('date');
        $object->section_id = $request->input('section_id', 0);
        $object->notes = $request->input('notes');
        $object->report_url = $request->input('report_url');

        if ($request->user()->hasRole('admin')) {

            // The Status may not be expressed in creation mode.
            if ($request->has('refunded')) {
                $object->refunded = (int) $request->input('refunded');
            }

            $object->user_id = $request->input('user_id', 0);
            $object->admin_notes = $request->input('admin_notes');
        } else {
            $object->user_id = $request->user()->id;
            $object->admin_notes = $object->admin_notes ?: '';
        }

        $status = null;
        if ($object->refunded) {
            $status = RefundStatus::findByID($object->refunded);
        }

        // Do not allow normal users to change an approved Amount.
        if ($request->has('amount')) {
            if (! $status || $status->isEditableByUser($request->user())) {
                $object->amount = $request->input('amount');
            }
        }


        return $object;
    }

    protected function defaultValidations($object)
    {
        return [
            'amount' => 'required|numeric',
            'notes' => 'required',
            'refunded' => 'numeric',
            'report_url' => 'nullable|url',
        ];
    }

    protected function defaultSortingColumn()
    {
        return 'date';
    }

    protected function afterSaving($request, $object)
    {
        if ($request->hasFile('file')) {
            $files = $request->file('file');

            foreach ($files as $f) {
                $object->attachFile($f);
            }
        }
    }

    /**
     * Get all possible options for the "With report" filter.
     * @return array
     */
    private function getReportURLOptions() {
        return [
            '-' => "Tutti",
            'yes' => "Report presente",
            'no' => "Report ancora da inserire",
        ];
    }
}

resources/views/refund/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <form method="POST" action="{{ route('refund.update', $object->id) }}" enctype="multipart/form-data">
                @method('PUT')
                @csrf

                @include('refund.form', ['object' => $object])

                @if($object)
                <div class="form-group row">
                    <label for="section_id" class="col-sm-4 col-form-label">Stato</label>
                    <div class="col-sm-8">
                        @if($currentuser->hasRole('admin'))
                        <select class="form-control" id="refunded" name="refunded">
                            @foreach(\App\RefundStatus::all() as $status)
                                <option value="{{ $status->id }}" @selected($status->id == $object->refunded)>{{ $status->label }}</option>
                            @endforeach
                        </select>
                        @else
                            <!-- TODO: improve this graphically :) -->
                            <input type="text" value="{{ $object->getRefundStatus()->label}}" readonly disabled>
                        @endif
                    </div>
                </div>
                @endif

                <hr>

                <div class="form-group row">
                    <div class="col-sm-10">
                        <button type="submit" class="btn btn-primary">Salva</button>
                    </div>
                </div>
            </form>

            <br>

            @can('delete', $object)
                <form method="POST" action="{{ route('refund.destroy', $object->id) }}">
                    @method('DELETE')
                    @csrf

                    <div class="form-group row">
                        <div class="col-sm-10">
                            <button type="submit" class="btn btn-danger">Elimina Richiesta di Rimborso Spese</button>
                        </div>
                    </div>
                </form>
            @endcan
        </div>
    </div>
</div>
@endsection

resources/views/refund/form.blade.php
<h2>Dati del rimborso</h2>

<div class="form-group row">
    <label for="date" class="col-sm-4 col-form-label">Data</label>
    <div class="col-sm-8">
        <input type="text" class="form-control" name="date" value="{{ $object ? $object->date : date('Y-m-d') }}" required>
    </div>
</div>
<div class="form-group row">
    <label for="amount" class="col-sm-4 col-form-label">Ammontare</label>
    <div class="col-sm-8">
        <input type="number" class="form-control" step="0.01" name="amount" value="{{ $object ? $object->amount : '' }}" required @readonly( $object && !$object->getRefundStatus()->isEditableByUser($currentuser) )>
    </div>
</div>
@if ($currentuser->hasRole('admin'))
    <div class="form-group row">
        <label for="user_id" class="col-sm-4 col-form-label">Utente</label>
        <div class="col-sm-8">
            @include('user.select', ['name' => 'user_id', 'select' => ($object ? $object->user_id : $currentuser->id)])
        </div>
    </div>
@endif
<div class="form-group row">
    <label for="section_id" class="col-sm-4 col-form-label">Sezione Locale</label>
    <div class="col-sm-8">
        @include('section.select', ['name' => 'section_id', 'select' => ($object ? $object->section_id : 0)])
    </div>
</div>
<div class="form-group row multiple-files">
    <label for="file" class="col-sm-4 col-form-label">File</label>
    <div class="col-sm-8">
        @if ($object)
            <ul>
                @foreach ($object->attachments as $attach)
                    <li><a href="{{ route('refund.download', ['file' => $object->id . '/' . $attach]) }}">{{ basename($attach) }}</a></li>
                @endforeach
            </ul>
        @endif

        <input type="file" name="file[]" autocomplete="off" {{ $object ? '' : 'required' }}>
        <small class="form-text text-muted">Si prega di allegare tutta la documentazione correlata: fatture, scontrini, biglietti...</small>
    </div>
</div>
<div class="form-group row">
    <label for="notes" class="col-sm-4 col-form-label">Note socio</label>
    <div class="col-sm-8">
        <textarea class="form-control" name="notes" placeholder="Scrivere qui una breve descrizione delle spese affrontate e di come desideri ricevere il rimborso (fornisci un IBAN, ecc.)" required>{{ $object ? $object->notes : '' }}</textarea>
    </div>
</div>

@if( $object )
<hr />

<div class="form-group row">
    <label for="report_url" class="col-sm-4 col-form-label">Relazione Finale (URL)</label>
    <div class="col-sm-8">
        <input type="text" class="form-control" name="report_url" placeholder="https://" value="{{ $object ? $object->report_url : '' }}" />
        <p>La relazione finale è una breve e graziosa pagina web che descriva a tutti come si è svolta la vostra attività. La puoi pubblicare su un qualsiasi sito (o forum ecc.) per descrivere cosa è andato bene, cosa sarebbe potuto andare meglio, come sono stati effettivamente utilizzati i fondi e descrivendo i risultati attesi e i risultati ottenuti. Non dimenticare qualche bella foto (fai punti bonus se sono in licenza libera!) e non dimenticarti di dare i giusti crediti e ringraziamenti alle persone e organizzazioni che hanno partecipato e vi hanno sostenuto moralmente o economicamente.</p>
    </div>
</div>
@endif

<h2>Dati dalla Segreteria</h2>

<div class="form-group row">
    <label for="admin_notes" class="col-sm-4 col-form-label">Note Segreteria</label>
    <div class="col-sm-8">
        <textarea class="form-control" name="admin_notes" placeholder="Informazioni dell'amministratore riguardo lo stato di avanzamento del rimborso" {{ $currentuser->hasRole('admin') ? '' : 'readonly' }}>{{ $object ? $object->admin_notes : '' }}</textarea>
    </div>
</div>

resources/views/refund/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#createUser">Nuovo Rimborso Spese</button>
            <div class="modal fade" id="createUser" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Nuovo Rimborso Spese</h5>
                            <button type="button" class="close" data-dismiss="modal">
                                <span>&times;</span>
                            </button>
                        </div>
                        <form method="POST" action="{{ route('refund.store') }}" enctype="multipart/form-data">
                            @csrf
                            <div class="modal-body">
                                @include('refund.form', ['object' => null])
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Annulla</button>
                                <button type="submit" class="btn btn-primary">Salva</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <form method="GET" action="" class="auto-filter-form">
        <div class="row mt-3">
            <div class="col-md-3">
                <div class="form-group">
                    <label for="refunded">Stato:</label>

                    @foreach($all_statuses as $status)
                        <div>
                            <input id="refund-uid-{{ $status->uid }}" type="checkbox" name="status[]" value="{{ $status->uid }}" @checked(in_array($status->uid, $selected_refund_status_uids))>
                            <label for="refund-uid-{{ $status->uid }}">{{ $status->label }}</label>
                        </div>
                    @endforeach
                </div>
            </div>

            @if($currentuser->hasRole('admin'))
            <div class="col-md-3">
                <div class="form-group">
                    <label for="user_id">Socio:</label>
                    <select id="user_id" name="user_id" class="form-control">
                        <option value="">Tutti</option>

                        @foreach($users as $user)
                            <option value="{{ $user->id }}" @selected(app('request')->input('user_id') == $user->id)>{{ $user->printable_name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            @endif

            <div class="col-md-3">
                <div class="form-group">
                    <label for="section_id">Sezione:</label>
                    <select id="section_id" name="section_id" class="form-control">
                        <option value="">Tutte</option>

                        @foreach($sections as $section)
                            <option value="{{ $section->id }}" @selected(app('request')->input('section_id') == $section->id)>{{ $section->city }}</option>
                        @endforeach
                    </select>
                </div>
            </div>

            <div class="col-md-3">
                <div class="form-group">
                    <label for="year">Anno:</label>

                    <select name="year" id="year" class="form-control">
                        <option value="">Tutti</option>

                        @for($y=$max_year; $y>=$min_year; $y--)
                            <option value="{{ $y }}" @selected(app('request')->input('year') == $y)>{{ $y }}</option>
                        @endfor
                    </select>
                </div>
            </div>

            <div class="col-md-3">
                <div class="form-group">
                    <label for="reporturl">Report:</label>
                    <select id="reporturl" name="report" class="form-control">
                        @foreach($report_options as $value => $label)
                            <option value="{{ $value }}" @selected($value === app('request')->input('report'))>{{ $label }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
        </div>
    </form>

    <div class="row mt-3">
        <div class="col-md-12">
            <table class="table">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>Data</th>
                        <th>Socio</th>
                        <th>Sezione</th>
                        <th>Importo</th>
                        <th>Da rimborsare</th>
                        <th>Stato</th>
                        <th>Dettagli</th>
                    </tr>
                </thead>
                <tbody>
                    
                    @foreach($objects as $refund)
                        <tr>
                            <td>{{ $refund->id }}</td>
                            <td>{{ $refund->date }}</td>
                            <td>{{ $refund->user ? $refund->user->printable_name : '' }}</td>
                            <td>{{ $refund->section ? $refund->section->city : '' }}</td>
                            <td class="text-right">{{ $refund->amount }}</td>
                            <td class="text-right">{{ $refund->getRefundStatus()->completed ? '0.00' : $refund->amount }}</td>
                            <td class="text-center">
                                {{ $refund->getRefundStatus()->label }}
                                <br>
                                <div class="progress mini-progress-bar">
                                    <div class="progress-bar bg-{{ $refund->getRefundStatus()->color }}" role="progressbar" style="width: {{ $refund->getRefundStatus()->percent }}%;" aria-valuenow="25" aria-valuemin="0" aria-valuemax="100"></div>
                                </div>
                            </td>
                            <td>
                                <a href="{{ route('refund.edit', $refund->id) }}"><span class="oi oi-pencil"></span></a>
                            </td>
                        </tr>
                    @endforeach
                </tbody>

                <tfoot>
                    <tr>
                        <td colspan="4" class="text-right">Totale</td>
                        <td class="text-right">{{ number_format($total, 2) }}</td>
                        <td class="text-right">{{ number_format($total_refunded, 2) }}</td>
                        <td colspan="2"></td>
                    </tr>
                </tfoot>
            </table>
        </div>
    </div>
</div>
@endsection